event = nil

function choose_random_event()

    print("choosing event...")
    local rand = Random(1,100)
    print("You got a "..rand)

    if(test_event and test_event.probability > 0) then event = test_event end

    highest_event = {difference = 9999, event = nil}
    while(not event and #events_list > 0) do -- As long as there are events left and no event has been chosen
        local index = Random(1,#events_list) -- Jumps through the events randomly, because if there are multiple events with the same probability, we want to chose one at random
        local item = events_list[index]

        
        local rand2 = Random(0,item.probability)
        local difference = math.abs(rand - item.probability)- rand2
        print(difference.."(-"..rand2.."): "..item.message)
        if(difference < highest_event.difference) then -- This gets the closest probability to the random number
            highest_event.difference = difference
            highest_event.event = item
        end
        --print(item.message)
        if(rand <= item.probability * probability_multiplier) then event = item
        else table.remove(events_list, index) end
    end

    if(not event and always_choose_event) then 
        print("Forcing event")
        event = highest_event.event 
    end
end

function OnMagicNumbersAndWorldSeedInitialized()
    print("Random start events initialized")
    seed = StatsGetValue("world_seed")
    SetRandomSeed(seed, seed)

    dofile_once("mods/random_start_events/events.lua") -- This is done here so that Random() and other functions can be used within events.lua
    choose_random_event()
    if(event) then print("Event has been chosen, message: "..event.message)
    else print("Unlucky! No event chosen") end
end


function OnPlayerSpawned(player_entity)
    local eventGlobal = GlobalsGetValue("event", 0)
    if(eventGlobal ~= "0") then --Ensures it only does the event once per run, even if you restart the game
           GamePrint("Event: "..eventGlobal)
        return
    end

   -- GamePrint("Event starting")
    if(event) then
        local value = event.event(player_entity)
        if(event.message and event.message ~= "") then
            if(value) then
                event.message = string.gsub(event.message, "$return", tostring(value))
                event.description = string.gsub(event.description, "$return", tostring(value))
            end
            GamePrintImportant(event.message, event.description)
            
        end
    else
        GamePrint("No event! Unlucky!")
    end
    if(event) then 
        GlobalsSetValue("event", string.gsub(event.message.." | "..event.description, "\"", "'"))
    else GlobalsSetValue("event", "No event") end
end